<?php
/**
 * Created by PhpStorm.
 * User: rafaelpickbrenne
 * Date: 14/11/2014
 * Time: 11:07
 *
 * Responsável por direcionar ao facade correspondente a tela
 */

namespace Folha\Facade\Relatorios;
//use \Folha\Facade\Relatorios\RelatoriosVabExport;

class RelatoriosDirecionador {
    /**
     * Função para redicionar para o facade correspondente. Isto se deve ao fato de uma Action ser chamada por várias
     * Windows.
     * @param string $nomeFuncao
     */
    public static function direcionar($nomeFuncao) {
        $nomeWindow = tk_get_active_window_name();
        switch($nomeWindow){
            case 'win_vab00011_000':    //Exportação de Vale Transporte
                self::abrirFuncao($nomeFuncao, new RelatoriosVabExport());
                break;
            case 'hrm_relatorio_admissao':  //Relatórios para Admissão
                self::abrirFuncao($nomeFuncao, new relatoriosAdmissao());
                break;
//            case 'hrm_relatorio_admissao':  //Relatórios para Admissão
//                self::abrirFuncao($nomeFuncao, new hrm_relatorio_admissao());
//                break;
            default:
                tk_warning('Ocorreu um erro. Por favor contate o suporte técnico e informe "window '.$nomeWindow.' não está integrada ao facade redicionador".');
        }
    }

    /**
     * Função auxiliar utilizada pela direcionar() para chamar o método correspondente
     * @param string $nomeFuncao
     * @param RelatoriosVabExport $objeto
     * @param relatoriosAdmissao $objeto
     */
    public static function abrirFuncao($nomeFuncao, $objeto) {
        if(method_exists($objeto, $nomeFuncao)){    //Verifica se o método existe e o executa
            call_user_func(array($objeto, $nomeFuncao));
        }else{                                      //Método inexistente.
            tk_warning('Ocorreu um erro. Por favor contate o suporte técnico e informe que a "função '.$nomeFuncao.' não está integrada ao facade redicionador".');
        }
    }
}