/******************************************************************************/
/******************************************************************************/
/* Trigger: DTULTATU_PRODMECA                                                 */
/* Tabela : PRODMECA                                                          */
/*                                                                            */
/* Criao:                                                                   */
/* 02/02/2005 - Jonathan Abdon Silva                                          */
/*                                                                            */
/******************************************************************************/

IF EXISTS(SELECT * FROM sysobjects O, sysusers U
          WHERE
            o.name = 'DTULTATU_PRODMECA'  and
            type = 'TR'                   and
            u.uid = o.uid                 and
            u.name = USER)
  DROP TRIGGER DTULTATU_PRODMECA
  GO


CREATE TRIGGER DTULTATU_PRODMECA
ON PRODMECA
FOR INSERT, UPDATE, DELETE
AS
BEGIN
   IF (0 = (SELECT COUNT(*) FROM INSERTED)) BEGIN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
                              (SELECT 'PRODMECA', NULL, 'CDPRODUTO='+CDPRODUTO+';CDMEDICASE='+CDMEDICASE+';', GETDATE() FROM DELETED)
   END
   ELSE BEGIN
      UPDATE PRODMECA
      SET DTULTATUPRME = GETDATE()
      FROM INSERTED
      WHERE
         (PRODMECA.CDMEDICASE = INSERTED.CDMEDICASE) AND
         (PRODMECA.CDPRODUTO  = INSERTED.CDPRODUTO)
   END;
END;
GO
