var Rec01400_Relatorio_Customizavel_Curva_ABC_Clientes = function(templateManager, ScreenService, General, ZhFilterPreferences, restEngine){
    /**
     * Variáveis de Inicialização
     **/
    var self = this;
    
    /**
     * Abertura do filtro de relatório ao carregar a tela
     * @param widget 
    */
     
    self.openFilterRelatorio = function(widget){
      ZhFilterPreferences.openFilterWidget(widget);
    };

    /**
     * Função para habilitar o campo de Data de Baixa
     * @param widget 
    */

    self.openFilterDate = function(widget){
      var fieldStatus = widget.getField("STATUS");
      var fieldVencimento = widget.getField("DTATUAVENREC");
      var fieldDataBaixa = widget.getField("DTBAIXAREC");
      if (fieldStatus.value() == 'B') {
        fieldDataBaixa.isVisible = true;
        fieldVencimento.class = 4;
        fieldStatus.class = 4;
        fieldDataBaixa.class = 4;
       } else {
        fieldDataBaixa.isVisible = false;
        fieldVencimento.class = 9;
        fieldStatus.class = 3;
      }
      widget.reload();
    };
    
    /**
     * Apliaca o filtro para a requisição dos dados do relatório
     * @param widget, preference
    */
    
    self.filterRelatorio = function(widget, preference) {
      
      var currentRowFiltro = preference.FILTER_ROW;
      var cdEmpresa = currentRowFiltro.EMPRESA;
      var cdCliente = currentRowFiltro.NMRAZSOCCLIE;
      var cdTipoConta = currentRowFiltro.DSTPCTRECEB;
      var cdStatus = currentRowFiltro.STATUS;
      var vencimento = currentRowFiltro.DTATUAVENREC;
      var dtBaixa = currentRowFiltro.DTBAIXAREC;
      var curvaGeral = currentRowFiltro.TIPOCURVA;

      if(dtBaixa === undefined) {
        dtBaixa = ({
          "end": '',
          "start": ''
        });
      }
      
      // Parametros do filtro do frontEnd
      var filter = [
          {
            'name': 'P_EMPRESA',
            'operator': '=',
            'value': cdEmpresa
          },
          {
            'name': 'P_CLIENTE',
            'operator': '=',
            'value': cdCliente
          },
          {
            'name': 'P_TIPOCONTA',
            'operator': '=',
            'value': cdTipoConta
          },
          {
            'name': 'P_STATUS',
            'operator': '=',
            'value': cdStatus
          },
          {
            'name': 'P_DTINIVENC',
            'operator': '=',
            'value': vencimento.start
          },
          {
            'name': 'P_DTFINVENC',
            'operator': '=',
            'value': vencimento.end
          },
          {
            'name': 'P_DTINIBAIXA',
            'operator': '=',
            'value': dtBaixa.start
          },
          {
            'name': 'P_DTFINBAIXA',
            'operator': '=',
            'value': dtBaixa.end
          },
          {
            'name': 'P_TDTBAIXAREC',
            'operator': '=',
            'value': 'T'
          },
          {
            'name': 'P_IDCURVAGERAL',
            'operator': '=',
            'value': curvaGeral
          }
        ];
        
      // rota backend, passando como parametro os dados do filtro da tela
      restEngine.post('/executaProcedureCurvaAbcCliente', {
            "requestType": "Row",
            "row": filter
        }).then((response) => {
          var dados = response.dataset.relatorio_curva_abc_de_clientes.relatorio_curva_abc_de_clientes;
          widget.dataSourceFilter = {};
          widget.dataSourceFilter = [
              {
                'name': 'P_NRSEQCURVAABCCLI',
                'operator': '=',
                'value': dados
              }
            ];
            widget.reload();
        });
    };
};
Configuration(function (ContextRegister){
    ContextRegister.register('Rec01400_Relatorio_Customizavel_Curva_ABC_Clientes', Rec01400_Relatorio_Customizavel_Curva_ABC_Clientes);
});